function activeObjTest()
    local name = osrs.ClientOp.obj_name()
    local type = osrs.ClientOp.obj_type()
    local count = osrs.ClientOp.obj_count()
    local coord = osrs.ClientOp.obj_coord(false)
    osrs.ClientOp.highlight_tile_on(coord:toBitPacked(), 6, true)
    local op1 = osrs.ClientOp.obj_getop(1, 1)
    local op2 = osrs.ClientOp.obj_getop(1, 2)
    local op3 = osrs.ClientOp.obj_getop(1, 3)
    local op4 = osrs.ClientOp.obj_getop(1, 4)
    local op5 = osrs.ClientOp.obj_getop(1, 5)
    osrs.print(string.format("'%s' | TYPE:%i | X:%i, Y:%i, Z:%i | PACKED COORD:%i | COUNT:%i | OPS: %s, %s, %s, %s, %s\n", 
        name, type, coord.x, coord.y, coord.z, coord:toBitPacked(), count, op1, op2, op3, op4, op5))
end

function nearbyObjTest(searchRadius)
    local playerCoord = osrs.ClientOp.coord(false)
    local gridSize = searchRadius * 2 + 1
    osrs.print(string.format("Highlighting all Bones objs '526' in a %ix%i grid from player tile...\n", gridSize, gridSize))
    for x = playerCoord.x - searchRadius, playerCoord.x + searchRadius, 1 do
        for z = playerCoord.z - searchRadius, playerCoord.z + searchRadius, 1 do
            local currentCoord = osrs.Coord.new(playerCoord.level, x, z, false, false)
            local foundLoc = osrs.ClientOp.obj_find(526, currentCoord:toBitPacked())

            if foundLoc then                
                osrs.ClientOp.highlight_tile_on(currentCoord:toBitPacked(), 6, true)
            end
        end
    end    
end

function onKeyDown(keycode)
    if keycode == 42 then
        nearbyObjTest(5)
    elseif keycode == 43 then
        activeObjTest()
    end
end

function startUp()
    osrs.print("Obj-Checker Controls:")
    osrs.print("'[' - Highlight nearby Bones objs that are of type ID '526'")
    osrs.print("']' - Highlight & print information about the last active obj.")
    callbackID = osrs.Events:subscribe(onKeyDown, osrs.Events.KEY_DOWN, callbackID)
end

startUp()
